/* MultiFileProgress.c generated by valac 0.10.0, the Vala compiler
 * generated from MultiFileProgress.vala, do not modify */

/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>


#define TYPE_MULTI_FILE_PROGRESS_INTERFACE (multi_file_progress_interface_get_type ())
#define MULTI_FILE_PROGRESS_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MULTI_FILE_PROGRESS_INTERFACE, MultiFileProgressInterface))
#define IS_MULTI_FILE_PROGRESS_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MULTI_FILE_PROGRESS_INTERFACE))
#define MULTI_FILE_PROGRESS_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MULTI_FILE_PROGRESS_INTERFACE, MultiFileProgressInterfaceIface))

typedef struct _MultiFileProgressInterface MultiFileProgressInterface;
typedef struct _MultiFileProgressInterfaceIface MultiFileProgressInterfaceIface;

#define TYPE_MULTI_FILE_PROGRESS (multi_file_progress_get_type ())
#define MULTI_FILE_PROGRESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MULTI_FILE_PROGRESS, MultiFileProgress))
#define MULTI_FILE_PROGRESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MULTI_FILE_PROGRESS, MultiFileProgressClass))
#define IS_MULTI_FILE_PROGRESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MULTI_FILE_PROGRESS))
#define IS_MULTI_FILE_PROGRESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MULTI_FILE_PROGRESS))
#define MULTI_FILE_PROGRESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MULTI_FILE_PROGRESS, MultiFileProgressClass))

typedef struct _MultiFileProgress MultiFileProgress;
typedef struct _MultiFileProgressClass MultiFileProgressClass;
typedef struct _MultiFileProgressPrivate MultiFileProgressPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define LOGGING_TYPE_FACILITY (logging_facility_get_type ())

#define LOGGING_TYPE_LEVEL (logging_level_get_type ())

struct _MultiFileProgressInterfaceIface {
	GTypeInterface parent_iface;
	void (*cancel) (MultiFileProgressInterface* self);
	void (*complete) (MultiFileProgressInterface* self);
};

struct _MultiFileProgress {
	GtkWindow parent_instance;
	MultiFileProgressPrivate * priv;
};

struct _MultiFileProgressClass {
	GtkWindowClass parent_class;
};

struct _MultiFileProgressPrivate {
	GtkProgressBar* progress_bar;
	GtkLabel* file_label;
	GtkLabel* number_label;
	GtkButton* cancel_button;
	gint num_files;
	gboolean needs_show;
	MultiFileProgressInterface* provider_interface;
	char* dialog_title;
};

typedef enum  {
	LOGGING_FACILITY_SIGNAL_HANDLERS,
	LOGGING_FACILITY_DEVELOPER_WARNINGS,
	LOGGING_FACILITY_GRAPH,
	LOGGING_FACILITY_LOADING,
	LOGGING_FACILITY_IMPORT,
	LOGGING_FACILITY_SINGLEDECODEBIN
} LoggingFacility;

typedef enum  {
	LOGGING_LEVEL_CRITICAL,
	LOGGING_LEVEL_HIGH,
	LOGGING_LEVEL_MEDIUM,
	LOGGING_LEVEL_LOW,
	LOGGING_LEVEL_INFO,
	LOGGING_LEVEL_VERBOSE
} LoggingLevel;


static gpointer multi_file_progress_parent_class = NULL;

GType multi_file_progress_interface_get_type (void) G_GNUC_CONST;
void multi_file_progress_interface_cancel (MultiFileProgressInterface* self);
void multi_file_progress_interface_complete (MultiFileProgressInterface* self);
GType multi_file_progress_get_type (void) G_GNUC_CONST;
#define MULTI_FILE_PROGRESS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MULTI_FILE_PROGRESS, MultiFileProgressPrivate))
enum  {
	MULTI_FILE_PROGRESS_DUMMY_PROPERTY
};
MultiFileProgress* multi_file_progress_new (GtkWindow* parent, gint num_files, const char* dialog_title, MultiFileProgressInterface* provider);
MultiFileProgress* multi_file_progress_construct (GType object_type, GtkWindow* parent, gint num_files, const char* dialog_title, MultiFileProgressInterface* provider);
static void multi_file_progress_on_cancel_clicked (MultiFileProgress* self);
static void _multi_file_progress_on_cancel_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void multi_file_progress_on_fraction_updated (MultiFileProgress* self, double d);
static void _multi_file_progress_on_fraction_updated_multi_file_progress_interface_fraction_updated (MultiFileProgressInterface* _sender, double d, gpointer self);
static void multi_file_progress_on_file_updated (MultiFileProgress* self, const char* filename, gint index);
static void _multi_file_progress_on_file_updated_multi_file_progress_interface_file_updated (MultiFileProgressInterface* _sender, const char* filename, gint index, gpointer self);
static void multi_file_progress_on_done (MultiFileProgress* self);
static void _multi_file_progress_on_done_multi_file_progress_interface_done (MultiFileProgressInterface* _sender, gpointer self);
GType logging_facility_get_type (void) G_GNUC_CONST;
GType logging_level_get_type (void) G_GNUC_CONST;
void logging_emit (GObject* object, LoggingFacility facility, LoggingLevel level, const char* message);
static void multi_file_progress_on_destroy (MultiFileProgress* self);
static void _multi_file_progress_on_destroy_gtk_object_destroy (GtkObject* _sender, gpointer self);
static void multi_file_progress_finalize (GObject* obj);


static void g_cclosure_user_marshal_VOID__STRING_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

void multi_file_progress_interface_cancel (MultiFileProgressInterface* self) {
	MULTI_FILE_PROGRESS_INTERFACE_GET_INTERFACE (self)->cancel (self);
}


void multi_file_progress_interface_complete (MultiFileProgressInterface* self) {
	MULTI_FILE_PROGRESS_INTERFACE_GET_INTERFACE (self)->complete (self);
}


static void multi_file_progress_interface_base_init (MultiFileProgressInterfaceIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_signal_new ("fraction_updated", TYPE_MULTI_FILE_PROGRESS_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
		g_signal_new ("file_updated", TYPE_MULTI_FILE_PROGRESS_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_INT, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_INT);
		g_signal_new ("done", TYPE_MULTI_FILE_PROGRESS_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	}
}


GType multi_file_progress_interface_get_type (void) {
	static volatile gsize multi_file_progress_interface_type_id__volatile = 0;
	if (g_once_init_enter (&multi_file_progress_interface_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MultiFileProgressInterfaceIface), (GBaseInitFunc) multi_file_progress_interface_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType multi_file_progress_interface_type_id;
		multi_file_progress_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "MultiFileProgressInterface", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (multi_file_progress_interface_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&multi_file_progress_interface_type_id__volatile, multi_file_progress_interface_type_id);
	}
	return multi_file_progress_interface_type_id__volatile;
}


#line 71 "MultiFileProgress.vala"
static void _multi_file_progress_on_cancel_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 156 "MultiFileProgress.c"
	multi_file_progress_on_cancel_clicked (self);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 84 "MultiFileProgress.vala"
static void _multi_file_progress_on_fraction_updated_multi_file_progress_interface_fraction_updated (MultiFileProgressInterface* _sender, double d, gpointer self) {
#line 168 "MultiFileProgress.c"
	multi_file_progress_on_fraction_updated (self, d);
}


#line 107 "MultiFileProgress.vala"
static void _multi_file_progress_on_file_updated_multi_file_progress_interface_file_updated (MultiFileProgressInterface* _sender, const char* filename, gint index, gpointer self) {
#line 175 "MultiFileProgress.c"
	multi_file_progress_on_file_updated (self, filename, index);
}


#line 66 "MultiFileProgress.vala"
static void _multi_file_progress_on_done_multi_file_progress_interface_done (MultiFileProgressInterface* _sender, gpointer self) {
#line 182 "MultiFileProgress.c"
	multi_file_progress_on_done (self);
}


#line 30 "MultiFileProgress.vala"
MultiFileProgress* multi_file_progress_construct (GType object_type, GtkWindow* parent, gint num_files, const char* dialog_title, MultiFileProgressInterface* provider) {
#line 189 "MultiFileProgress.c"
	MultiFileProgress * self;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkProgressBar* _tmp2_;
	GtkVBox* vbox;
	GtkHButtonBox* button_area;
	GtkButton* _tmp3_;
	char* _tmp4_;
	MultiFileProgressInterface* _tmp5_;
#line 30 "MultiFileProgress.vala"
	g_return_val_if_fail (GTK_IS_WINDOW (parent), NULL);
#line 30 "MultiFileProgress.vala"
	g_return_val_if_fail (dialog_title != NULL, NULL);
#line 30 "MultiFileProgress.vala"
	g_return_val_if_fail (IS_MULTI_FILE_PROGRESS_INTERFACE (provider), NULL);
#line 205 "MultiFileProgress.c"
	self = g_object_newv (object_type, 0, NULL);
#line 32 "MultiFileProgress.vala"
	self->priv->num_files = num_files;
#line 33 "MultiFileProgress.vala"
	self->priv->needs_show = TRUE;
#line 34 "MultiFileProgress.vala"
	self->priv->file_label = (_tmp0_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), _g_object_unref0 (self->priv->file_label), _tmp0_);
#line 35 "MultiFileProgress.vala"
	self->priv->number_label = (_tmp1_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), _g_object_unref0 (self->priv->number_label), _tmp1_);
#line 36 "MultiFileProgress.vala"
	self->priv->progress_bar = (_tmp2_ = g_object_ref_sink ((GtkProgressBar*) gtk_progress_bar_new ()), _g_object_unref0 (self->priv->progress_bar), _tmp2_);
#line 38 "MultiFileProgress.vala"
	vbox = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (TRUE, 0));
#line 40 "MultiFileProgress.vala"
	gtk_box_pack_start (GTK_BOX (vbox), GTK_WIDGET (self->priv->number_label), FALSE, FALSE, (guint) 0);
#line 41 "MultiFileProgress.vala"
	gtk_box_pack_start (GTK_BOX (vbox), GTK_WIDGET (self->priv->file_label), FALSE, FALSE, (guint) 0);
#line 42 "MultiFileProgress.vala"
	gtk_box_pack_start (GTK_BOX (vbox), GTK_WIDGET (self->priv->progress_bar), FALSE, FALSE, (guint) 0);
#line 44 "MultiFileProgress.vala"
	button_area = g_object_ref_sink ((GtkHButtonBox*) gtk_hbutton_box_new ());
#line 45 "MultiFileProgress.vala"
	g_object_set (G_OBJECT (button_area), "layout-style", GTK_BUTTONBOX_CENTER, NULL);
#line 47 "MultiFileProgress.vala"
	self->priv->cancel_button = (_tmp3_ = g_object_ref_sink ((GtkButton*) gtk_button_new_from_stock (GTK_STOCK_CANCEL)), _g_object_unref0 (self->priv->cancel_button), _tmp3_);
#line 48 "MultiFileProgress.vala"
	g_signal_connect_object (self->priv->cancel_button, "clicked", (GCallback) _multi_file_progress_on_cancel_clicked_gtk_button_clicked, self, 0);
#line 50 "MultiFileProgress.vala"
	gtk_container_add (GTK_CONTAINER (button_area), GTK_WIDGET (self->priv->cancel_button));
#line 52 "MultiFileProgress.vala"
	gtk_box_pack_start (GTK_BOX (vbox), GTK_WIDGET (button_area), FALSE, FALSE, (guint) 0);
#line 53 "MultiFileProgress.vala"
	gtk_container_add (GTK_CONTAINER (self), GTK_WIDGET (vbox));
#line 55 "MultiFileProgress.vala"
	gtk_window_set_transient_for (GTK_WINDOW (self), parent);
#line 56 "MultiFileProgress.vala"
	gtk_window_set_title (GTK_WINDOW (self), dialog_title);
#line 57 "MultiFileProgress.vala"
	self->priv->dialog_title = (_tmp4_ = g_strdup (dialog_title), _g_free0 (self->priv->dialog_title), _tmp4_);
#line 59 "MultiFileProgress.vala"
	self->priv->provider_interface = (_tmp5_ = _g_object_ref0 (provider), _g_object_unref0 (self->priv->provider_interface), _tmp5_);
#line 61 "MultiFileProgress.vala"
	g_signal_connect_object (self->priv->provider_interface, "fraction-updated", (GCallback) _multi_file_progress_on_fraction_updated_multi_file_progress_interface_fraction_updated, self, 0);
#line 62 "MultiFileProgress.vala"
	g_signal_connect_object (self->priv->provider_interface, "file-updated", (GCallback) _multi_file_progress_on_file_updated_multi_file_progress_interface_file_updated, self, 0);
#line 63 "MultiFileProgress.vala"
	g_signal_connect_object (self->priv->provider_interface, "done", (GCallback) _multi_file_progress_on_done_multi_file_progress_interface_done, self, 0);
#line 253 "MultiFileProgress.c"
	_g_object_unref0 (button_area);
	_g_object_unref0 (vbox);
	return self;
}


#line 30 "MultiFileProgress.vala"
MultiFileProgress* multi_file_progress_new (GtkWindow* parent, gint num_files, const char* dialog_title, MultiFileProgressInterface* provider) {
#line 30 "MultiFileProgress.vala"
	return multi_file_progress_construct (TYPE_MULTI_FILE_PROGRESS, parent, num_files, dialog_title, provider);
#line 264 "MultiFileProgress.c"
}


#line 66 "MultiFileProgress.vala"
static void multi_file_progress_on_done (MultiFileProgress* self) {
#line 66 "MultiFileProgress.vala"
	g_return_if_fail (IS_MULTI_FILE_PROGRESS (self));
#line 67 "MultiFileProgress.vala"
	logging_emit (G_OBJECT (self), LOGGING_FACILITY_SIGNAL_HANDLERS, LOGGING_LEVEL_INFO, "on_done");
#line 68 "MultiFileProgress.vala"
	gtk_object_destroy (GTK_OBJECT (self));
#line 276 "MultiFileProgress.c"
}


#line 71 "MultiFileProgress.vala"
static void multi_file_progress_on_cancel_clicked (MultiFileProgress* self) {
#line 71 "MultiFileProgress.vala"
	g_return_if_fail (IS_MULTI_FILE_PROGRESS (self));
#line 72 "MultiFileProgress.vala"
	logging_emit (G_OBJECT (self), LOGGING_FACILITY_SIGNAL_HANDLERS, LOGGING_LEVEL_INFO, "on_cancel_clicked");
#line 73 "MultiFileProgress.vala"
	gtk_object_destroy (GTK_OBJECT (self));
#line 288 "MultiFileProgress.c"
}


#line 76 "MultiFileProgress.vala"
static void multi_file_progress_on_destroy (MultiFileProgress* self) {
#line 76 "MultiFileProgress.vala"
	g_return_if_fail (IS_MULTI_FILE_PROGRESS (self));
#line 77 "MultiFileProgress.vala"
	logging_emit (G_OBJECT (self), LOGGING_FACILITY_SIGNAL_HANDLERS, LOGGING_LEVEL_INFO, "on_destroy");
#line 78 "MultiFileProgress.vala"
	if (gtk_progress_bar_get_fraction (self->priv->progress_bar) < 1.0) {
#line 79 "MultiFileProgress.vala"
		multi_file_progress_interface_cancel (self->priv->provider_interface);
#line 302 "MultiFileProgress.c"
	} else {
#line 81 "MultiFileProgress.vala"
		multi_file_progress_interface_complete (self->priv->provider_interface);
#line 306 "MultiFileProgress.c"
	}
}


#line 76 "MultiFileProgress.vala"
static void _multi_file_progress_on_destroy_gtk_object_destroy (GtkObject* _sender, gpointer self) {
#line 313 "MultiFileProgress.c"
	multi_file_progress_on_destroy (self);
}


#line 84 "MultiFileProgress.vala"
static void multi_file_progress_on_fraction_updated (MultiFileProgress* self, double d) {
#line 84 "MultiFileProgress.vala"
	g_return_if_fail (IS_MULTI_FILE_PROGRESS (self));
#line 85 "MultiFileProgress.vala"
	logging_emit (G_OBJECT (self), LOGGING_FACILITY_SIGNAL_HANDLERS, LOGGING_LEVEL_INFO, "on_fraction_updated");
#line 86 "MultiFileProgress.vala"
	if (self->priv->needs_show) {
#line 87 "MultiFileProgress.vala"
		self->priv->needs_show = FALSE;
#line 88 "MultiFileProgress.vala"
		gtk_container_set_border_width (GTK_CONTAINER (self), (guint) 8);
#line 89 "MultiFileProgress.vala"
		gtk_window_set_resizable (GTK_WINDOW (self), FALSE);
#line 90 "MultiFileProgress.vala"
		gtk_window_set_modal (GTK_WINDOW (self), TRUE);
#line 92 "MultiFileProgress.vala"
		g_signal_connect_object (GTK_OBJECT (self), "destroy", (GCallback) _multi_file_progress_on_destroy_gtk_object_destroy, self, 0);
#line 94 "MultiFileProgress.vala"
		gtk_widget_show_all (GTK_WIDGET (self));
#line 338 "MultiFileProgress.c"
	}
#line 97 "MultiFileProgress.vala"
	gtk_progress_bar_set_fraction (self->priv->progress_bar, d);
#line 99 "MultiFileProgress.vala"
	if (gtk_progress_bar_get_fraction (self->priv->progress_bar) == 1.0) {
#line 100 "MultiFileProgress.vala"
		gtk_object_destroy (GTK_OBJECT (self));
#line 346 "MultiFileProgress.c"
	} else {
#line 102 "MultiFileProgress.vala"
		gtk_widget_show_all (GTK_WIDGET (self));
#line 103 "MultiFileProgress.vala"
		gtk_widget_queue_draw (GTK_WIDGET (self));
#line 352 "MultiFileProgress.c"
	}
}


#line 107 "MultiFileProgress.vala"
static void multi_file_progress_on_file_updated (MultiFileProgress* self, const char* filename, gint index) {
#line 359 "MultiFileProgress.c"
	char* _tmp0_;
	char* _tmp1_;
#line 107 "MultiFileProgress.vala"
	g_return_if_fail (IS_MULTI_FILE_PROGRESS (self));
#line 107 "MultiFileProgress.vala"
	g_return_if_fail (filename != NULL);
#line 108 "MultiFileProgress.vala"
	logging_emit (G_OBJECT (self), LOGGING_FACILITY_SIGNAL_HANDLERS, LOGGING_LEVEL_INFO, "on_file_updated");
#line 109 "MultiFileProgress.vala"
	gtk_label_set_text (self->priv->number_label, _tmp0_ = g_strdup_printf ("%sing %d of %d", self->priv->dialog_title, index + 1, self->priv->num_files));
#line 370 "MultiFileProgress.c"
	_g_free0 (_tmp0_);
#line 110 "MultiFileProgress.vala"
	gtk_label_set_text (self->priv->file_label, _tmp1_ = g_strdup_printf ("%s", filename));
#line 374 "MultiFileProgress.c"
	_g_free0 (_tmp1_);
}


static void multi_file_progress_class_init (MultiFileProgressClass * klass) {
	multi_file_progress_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MultiFileProgressPrivate));
	G_OBJECT_CLASS (klass)->finalize = multi_file_progress_finalize;
}


static void multi_file_progress_instance_init (MultiFileProgress * self) {
	self->priv = MULTI_FILE_PROGRESS_GET_PRIVATE (self);
}


static void multi_file_progress_finalize (GObject* obj) {
	MultiFileProgress * self;
	self = MULTI_FILE_PROGRESS (obj);
	_g_object_unref0 (self->priv->progress_bar);
	_g_object_unref0 (self->priv->file_label);
	_g_object_unref0 (self->priv->number_label);
	_g_object_unref0 (self->priv->cancel_button);
	_g_object_unref0 (self->priv->provider_interface);
	_g_free0 (self->priv->dialog_title);
	G_OBJECT_CLASS (multi_file_progress_parent_class)->finalize (obj);
}


GType multi_file_progress_get_type (void) {
	static volatile gsize multi_file_progress_type_id__volatile = 0;
	if (g_once_init_enter (&multi_file_progress_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MultiFileProgressClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) multi_file_progress_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MultiFileProgress), 0, (GInstanceInitFunc) multi_file_progress_instance_init, NULL };
		GType multi_file_progress_type_id;
		multi_file_progress_type_id = g_type_register_static (GTK_TYPE_WINDOW, "MultiFileProgress", &g_define_type_info, 0);
		g_once_init_leave (&multi_file_progress_type_id__volatile, multi_file_progress_type_id);
	}
	return multi_file_progress_type_id__volatile;
}



static void g_cclosure_user_marshal_VOID__STRING_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_INT) (gpointer data1, const char* arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_INT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_int (param_values + 2), data2);
}



